<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\LocalService;
use FM\Traits\TResponse;

class LocalController extends FMCrud{
    
    use TResponse;
    protected $LocalService;
   
    public function __construct($crudService, $environment, LocalService $LocalService) {
        parent::__construct($crudService, $environment);
        $this->LocalService = $LocalService;
    }
    
    public function getAllLocals(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();
        $var = $this->LocalService->getAllLocals($params);
        $dtsVal = new DataSet('Locals', $var);
        $response->addDataSet($dtsVal);
    }
    
    public function getLocals(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();
        $var = $this->LocalService->getLocals($params);
        $dtsVal = new DataSet('Locals', $var);
        $response->addDataSet($dtsVal);
    }
    
    public function Locals(DTO\Request $request, DTO\Response $response) {
        $response->addDataSet(new DataSet('Locals', $this->LocalService->Locals()));
    }
    
    public function LocalsDatasource(DTO\Request $request, DTO\Response $response) {
        try {
            $data = $this->LocalService->LocalsDatasource();
            $this->sendResponse($data, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
?>