<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use FM\Traits\TQuery;

class ParamGeralFactory {
    
    use TQuery;
    
    protected $connection;
    protected $entityManager;
    
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }
    
    public function postMascara($params){
        $sql="INSERT INTO FCM_PARAMGERAL (NRPARAMGERAL, IDOBRIGACDLOCAT, IDUTILIZAMASCCDLOCAT, DSMASCCDLOCAT, IDALTERAMASCCDLOCAT, IDATIVO,
                                            NRORG, DTINCLUSAO, CDOPERINCLUSAO, NRORGINCLUSAO, DTULTATU, CDOPERULTATU, NRORGULTATU)
                VALUES (:NRPARAMGERAL, :IDOBRIGACDLOCAT, :IDUTILIZAMASCCDLOCAT, :DSMASCCDLOCAT, :IDALTERAMASCCDLOCAT, 'S',
                         :NRORG, SYSDATE, :CDOPERINCLUSAO, :NRORGINCLUSAO, SYSDATE, :CDOPERULTATU, :NRORGULTATU)";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

    public function getMascara() {

        $sql="SELECT IDOBRIGACDLOCAT, IDUTILIZAMASCCDLOCAT, DSMASCCDLOCAT, IDALTERAMASCCDLOCAT 
                FROM FCM_PARAMGERAL";
                
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
    
    public function updateMascara($params){
        $sql="UPDATE FCM_PARAMGERAL 
                SET IDOBRIGACDLOCAT = :IDOBRIGACDLOCAT,
                IDUTILIZAMASCCDLOCAT = :IDUTILIZAMASCCDLOCAT,
                DSMASCCDLOCAT = : DSMASCCDLOCAT,
                IDALTERAMASCCDLOCAT = : IDALTERAMASCCDLOCAT,
                NRORGINCLUSAO = :NRORGINCLUSAO,
                DTULTATU = SYSDATE,
                CDOPERULTATU = :CDOPERULTATU,
                NRORGULTATU = :NRORGULTATU";
                  
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function getCountMascara(){
        $sql="SELECT COUNT(NRPARAMGERAL) AS QTA FROM FCM_PARAMGERAL";
                  
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
}

?>