<?php
namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class UsuariosFactory
{

    protected $connection;

    public function __construct(EntityManager $entityManager) {

        $this->connection = $entityManager->getConnection();
    }

    public function getUsersFactory($validParam) {
        $sql = " SELECT A.NRFUNCIONARIO, A.NMFUNCIONARIO, A.NRRGFUNCIONARIO, A.DSEMAILFUNCIONARIO,  A.NRCPFFUNCIONARIO, A.NRTELFUNCIONARIO, A.CDOPERADOR,
                        A.DSSENHAFUNC, D.NMPERFILACESSO, E.NMSETOR, C.NRSETOR,
                        C.NRSETOR, C.NRRELACFUNCSETOR, B.RELACFUNCPERFACESS, B.NRPERFILACESSO
                   FROM FCM_FUNCIONARIO A
              LEFT JOIN FCM_RELACFUNCPERFACESS B ON A.NRFUNCIONARIO = B.NRFUNCIONARIO
              LEFT JOIN FCM_PERFILACESSO D ON B.NRPERFILACESSO = D.NRPERFILACESSO
              LEFT JOIN FCM_RELACFUNCSETOR C ON A.NRFUNCIONARIO = C.NRFUNCIONARIO
              LEFT JOIN FCM_SETOR E ON C.NRSETOR = E.NRSETOR 
              WHERE A.IDATIVO = 'S' {$validParam}"; // Pode se referenciar tanto com chaves quanto com o ponto final " .$param"

        $std = $this->connection->prepare($sql);

        $std->execute();
        return $std->fetchAll();
    }

    public function usersListFactory() {
        $sql = "SELECT NRFUNCIONARIO, NMFUNCIONARIO
                    FROM FCM_FUNCIONARIO";

        $std = $this->connection->prepare($sql);

        $std->execute();
        return $std->fetchAll();
    }

    public function getOperadorFactory() {
        $sql = "SELECT CDOPERADOR, NMOPERADOR
                  FROM OPERADOR
                 WHERE IDATIVO = 'S'
                   AND IDOPERATIVO = 'A'";

        $std = $this->connection->prepare($sql);

        $std->execute();
        return $std->fetchAll();
    }

    public function createUserFactory($userInfos) {
        $sql = "INSERT INTO FCM_FUNCIONARIO (NRFUNCIONARIO, NMFUNCIONARIO, NRPESSOA, CDOPERADOR, 
                NRRGFUNCIONARIO, NRCPFFUNCIONARIO, DSEMAILFUNCIONARIO, HRENTRADAPADR, HRSAIDAPADR, NRORG, IDATIVO, 
                DTINCLUSAO, CDOPERINCLUSAO, NRORGINCLUSAO, IDTURNOFUNCIONARIO, NRTELFUNCIONARIO)
                        VALUES (:NRFUNCIONARIO, :NMFUNCIONARIO, :NRPESSOA, :CDOPERADOR, :NRRGFUNCIONARIO,
                               :NRCPFFUNCIONARIO, :DSEMAILFUNCIONARIO,  :HRENTRADAPADR, :HRSAIDAPADR,
                               :NRORG, :IDATIVO, SYSDATE, :OPERADOR, :NRORG, 
                               :IDTURNOFUNCIONARIO, :NRTELFUNCIONARIO)";

        $std = $this->connection->prepare($sql);

        $std->execute($userInfos);
    }

    public function createRelacPosFactory($relacPosInfos) {
        $sql = "INSERT INTO FCM_RELACFUNCPERFACESS (RELACFUNCPERFACESS, NRPERFILACESSO, NRFUNCIONARIO, NRORG, IDATIVO,
                                                    DTINCLUSAO, CDOPERINCLUSAO, NRORGINCLUSAO)
                    VALUES (:RELACFUNCPERFACESS, :NRPERFILACESSO, :NRFUNCIONARIO, :NRORG, :IDATIVO,
                            SYSDATE, :OPERADOR, :NRORG)";

        $std = $this->connection->prepare($sql);

        $std->execute($relacPosInfos);
    }

    public function createRelacSectorFactory($relacSectorInfos) {
        $sql = "INSERT INTO FCM_RELACFUNCSETOR (NRRELACFUNCSETOR, NRSETOR, NRFUNCIONARIO, NRORG, IDATIVO, DTINCLUSAO, CDOPERINCLUSAO, NRORGINCLUSAO)
                    VALUES(:NRRELACFUNCSETOR, :NRSETOR, :NRFUNCIONARIO, :NRORG, :IDATIVO, SYSDATE, :OPERADOR, :NRORG)";

        $std = $this->connection->prepare($sql);

        $std->execute($relacSectorInfos);
    }

    public function getUserInfosFactory($params) {
        $sql = "SELECT A.NRFUNCIONARIO, A.NMFUNCIONARIO, A.NRRGFUNCIONARIO, A.NRCPFFUNCIONARIO, A.CDOPERADOR,
                        A.DSEMAILFUNCIONARIO, A.NRTELFUNCIONARIO, A.DSSENHAFUNC, B.NRSETOR, B.NRRELACFUNCSETOR, C.RELACFUNCPERFACESS, C.NRPERFILACESSO
                 FROM FCM_FUNCIONARIO A
                 INNER JOIN FCM_RELACFUNCSETOR B   ON A.NRFUNCIONARIO = B.NRFUNCIONARIO
                 INNER JOIN FCM_RELACFUNCPERFACESS C ON A.NRFUNCIONARIO = C.NRFUNCIONARIO
                 WHERE A.NRFUNCIONARIO = :NRFUNCIONARIO" ;

        $std = $this->connection->prepare($sql);

        $std->execute($params);
        return $std->fetchAll();
    }

    public function getPasswordFactory($params) {
        $sql = "SELECT DSSENHAFUNC
                    FROM FCM_FUNCIONARIO
                 WHERE NRFUNCIONARIO = :NRFUNCIONARIO";

        $std = $this->connection->prepare($sql);

        $std->execute($params);
        return $std->fetchAll();
    }

    public function updateUserFactory($params){
        $sql = "UPDATE FCM_FUNCIONARIO
                   SET NMFUNCIONARIO = :NMFUNCIONARIO,
                       NRRGFUNCIONARIO = :NRRGFUNCIONARIO,
                       NRCPFFUNCIONARIO = :NRCPFFUNCIONARIO,
                       DSEMAILFUNCIONARIO = :DSEMAILFUNCIONARIO,
                       NRTELFUNCIONARIO = :NRTELFUNCIONARIO,
                       CDOPERADOR = :CDOPERADOR,
                       DTULTATU = SYSDATE
                 WHERE NRFUNCIONARIO = :NRFUNCIONARIO";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

    public function updateUserPasswordFactory($params){
        $sql = "UPDATE FCM_FUNCIONARIO
                   SET NMFUNCIONARIO = :NMFUNCIONARIO,
                       NRRGFUNCIONARIO = :NRRGFUNCIONARIO,
                       NRCPFFUNCIONARIO = :NRCPFFUNCIONARIO,
                       DSEMAILFUNCIONARIO = :DSEMAILFUNCIONARIO,
                       NRTELFUNCIONARIO = :NRTELFUNCIONARIO,
                       DSSENHAFUNC = :DSSENHAFUNC,
                       CDOPERADOR = :CDOPERADOR,
                       DTULTATU = SYSDATE
                 WHERE NRFUNCIONARIO = :NRFUNCIONARIO";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

    public function updateRelacPosFactory($params){
        $sql = "UPDATE FCM_RELACFUNCPERFACESS
                   SET NRPERFILACESSO = :NRPERFILACESSO
                 WHERE NRFUNCIONARIO = :NRFUNCIONARIO
                   AND RELACFUNCPERFACESS = :RELACFUNCPERFACESS ";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

    public function updateRelacSectorFactory($params){
        $sql = "UPDATE FCM_RELACFUNCSETOR
                   SET NRSETOR = :NRSETOR
                 WHERE NRFUNCIONARIO = :NRFUNCIONARIO
                   AND NRRELACFUNCSETOR = :NRRELACFUNCSETOR ";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

    public function deleteUsersFactory($params) {
        $sql = "DELETE FROM FCM_FUNCIONARIO
                 WHERE NRFUNCIONARIO = :NRFUNCIONARIO";

        $std = $this->connection->prepare($sql);

        $std->execute($params);
    }

    public function inativarUser($params) {
        // debugApi([$params]);
        $sql = "UPDATE FCM_FUNCIONARIO SET IDATIVO = 'N' WHERE NRFUNCIONARIO = :NRFUNCIONARIO";

        $std = $this->connection->prepare($sql);

        $std->execute($params);
    }

    public function validUsersFactory($params) {
        $sql = "SELECT COUNT (*) AS VALIDA
                    FROM FCM_CHECKLISTAGEND
                 WHERE NRFUNCIONARIO = :NRFUNCIONARIO";

        $std = $this->connection->prepare($sql);

        $std->execute($params);
        return $std->fetchAll();
    }

    public function validSectorUsersFactory($params) {
        $sql = "SELECT COUNT (*) AS VALIDA
                    FROM FCM_SETOR
                 WHERE NRFUNCRESPONSAVEL = :NRFUNCIONARIO";

        $std = $this->connection->prepare($sql);

        $std->execute($params);
        return $std->fetchAll();
    }


}
?>